#include "GL_DFSGraphTraversal.h"
#include "GL_DFSCoreWalker.h"
#include "GL_DFSGeometry3DWalker.h"
#include "GL_DFSGroupingWalker.h"
#include "GL_DFSRenderingWalker.h"
#include "GL_DFSShapeWalker.h"
#include "GL_DFSTexturingWalker.h"

#include <iostream>

namespace X3DTK {
namespace GL {

DFSGraphTraversal::DFSGraphTraversal()
: GraphTraversal()
{
  setComponentWalker(new DFSCoreWalker());
  setComponentWalker(new DFSGeometry3DWalker());
  setComponentWalker(new DFSGroupingWalker());
  setComponentWalker(new DFSRenderingWalker());
  setComponentWalker(new DFSShapeWalker());
  setComponentWalker(new DFSTexturingWalker());
}

DFSGraphTraversal::~DFSGraphTraversal()
{
}

void DFSGraphTraversal::setComponentWalker(X3DComponentWalker *component)
{
  GraphTraversal::setComponentWalker(component);
}

}
}
