#include "X3D_BBoxUpdaterNavigationVisitor.h"
#include "X3D_Collision.h"
#include "BBox.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

BBoxUpdaterNavigationVisitor::BBoxUpdaterNavigationVisitor()
: NavigationVisitor()
{
  // Leave functions.
  defineLeaveFunction(&BBoxUpdaterNavigationVisitor::leaveCollision);
  
  // StateVariables assignation.
  stateVariables = GraphTraversal::getInstanceOf<BBoxUpdaterStateVariables>();
}

BBoxUpdaterNavigationVisitor::~BBoxUpdaterNavigationVisitor()
{
}

void BBoxUpdaterNavigationVisitor::leaveCollision(Collision *C) const
{
  BBox *BB = stateVariables->getBBox(C);
  if (BB == 0)
  {
    MFNode children = C->getChildren();
    for (MFNode::iterator it = children.begin(); it != children.end(); ++it)
    {
      X3DBoundedObject *BO = dynamic_cast<X3DBoundedObject *>(*it);
      if (BO != 0)
        stateVariables->addBBoxToMergeList(BBox(BO->getBBoxCenter(), BO->getBBoxSize()));
    }
    
    BB = new BBox(stateVariables->mergeBBox()); 
    stateVariables->addBBox(C, BB);
    
    //updating the BBox attributes.
    C->setBBoxCenter(BB->getCenter());
    C->setBBoxSize(BB->getSize());
  }
}

}
}
