#include "GraphTesterAbstractVisitor.h"

#include <iostream>

using namespace std;

namespace X3DTK {

GraphTesterAbstractVisitor::GraphTesterAbstractVisitor()
{
  stateVariables = GraphTraversal::getInstanceOf<GraphTesterStateVariables>();
  
  defineEnterFunction(&GraphTesterAbstractVisitor::enterX3DAbstractNode);
}

GraphTesterAbstractVisitor::~GraphTesterAbstractVisitor()
{
}

void GraphTesterAbstractVisitor::enterX3DAbstractNode(X3DAbstractNode *N) const
{
  SFString name;
  if (N->getName() != "")
    name += " DEF = " + N->getName();
    
  cout << stateVariables->getTab() << N->getTypeName() << name << " := " << N << " -> ";
  MFAbstractNode list = N->getParentList();
  for (MFAbstractNode::const_iterator it = list.begin(); it != list.end(); ++it)
    cout << (*it)->getTypeName() << ", ";
  cout << endl;
  
  stateVariables->addTab();
}

void GraphTesterAbstractVisitor::leaveX3DAbstractNode(X3DAbstractNode *) const
{
  stateVariables->removeTab();
}

}
