#include "QFileElement.h"

#include <qxml.h>
#include <iostream>

using namespace std;

namespace X3DTK {

class QFileElementImplementation
{
public:
  QFileElementImplementation(){};
  
  SFString name;
  QXmlAttributes *attributes;
};

QFileElement::QFileElement(const SFString &name, const void *const attributes)
: impl(new QFileElementImplementation())
{
  impl->name = name;
  impl->attributes = (QXmlAttributes *)attributes;
}

QFileElement::~QFileElement()
{
}

SFString QFileElement::getName() const
{
  return impl->name;
}

SFString QFileElement::getAttribute(int i) const
{
  return (const char *)(impl->attributes->value(i));
}

int QFileElement::getIndexAttribute(const SFString &attribute) const
{
  return impl->attributes->index((const char *)attribute);
}

}
